#include <stdio.h>
#include <math.h>

/* Ce fichier lit pour l'instant une image au format PGM ASCII nomme image_in.pgm  en niveau de gris avec un entete du type "P2 256 256 255" signifiant qu'on a une image de taille 256 par 256 avec une dynamique en niveau de gris s'tendant en valeurs entieres entre 0 et 255;
   puis la reecrit dans le fichier image_out.pgm 

   Ce programme s'instancie de la maniere suivante : lit image_in image_out
*/

		      
int
main (argc,argv)
	int argc;
	char *argv[];
{
  
  int  largeur,hauteur,couleur;

  int pix;
  int i,j;

  FILE *fichier_in,*fichier_out;
  int *mat_in,*mat_out;                
  char file_in[100],file_out[100];


  /*Ouverture du fichier image a traiter*/
   
  if (argc!=3)
    
    {
      printf("Il faut deux arguments  : le nom de l'image a traiter puis le nom du fichier image resultat (sans l'extension pgm a chaque fois)\n");
      exit(0);
    }
  
  else 
    {
      sprintf(file_in,"%s.pgm",argv[1]);
      sprintf(file_out,"%s.pgm",argv[2]);
    }
  

  fichier_in=fopen(file_in,"r");

  /**Pour passer l'en-tete sans information interessante : variable en fonction de ce qui a cr vos
     images : pour passer P5 ou P2 par exemple dans les images pgm**/
  
  fscanf(fichier_in,"%*s");

  /**Pour passer la ligne de commentaire ventuelle commencant par #  : vous n'aurez qu' commenter
     cette partie de code si vos images n'ont pas cete ligne***/
  /* pix=getc(fichier);
     do 
     {
     pix=getc(fichier);
     
     } while (pix!='\n');
  */
  
  /*** Lit la longueur, la largeur,(ordre  vrifier) et la dynamique en intensit***/

  fscanf(fichier_in,"%d",&largeur);
  printf("largeur = %d\n",largeur);
  fscanf(fichier_in,"%d",&hauteur);
  printf("hauteur = %d\n",hauteur);
  fscanf(fichier_in,"%d",&couleur);
  printf("dynamique = %d\n",couleur);

  mat_in=(int *) malloc(sizeof(int)*largeur*hauteur);
  mat_out=(int *) malloc(sizeof(int)*largeur*hauteur);


  
  /***Lit la valeur d'intensit du pixel en unsigned char si possible (ici en char) et la met dans la matrice mat***/
  
  for (i=0;i<hauteur;i++)
    for (j=0;j<largeur;j++)
      {
	fscanf(fichier_in,"%d",&pix);
	mat_in[i*largeur+j]=pix;
      }
  fclose(fichier_in);
  
  /*** Votre traitement intervient entre temps : Sobel, Deriche.... : pour l'instant simple copie de mat_in dans mat_out***/
  for (i=0;i<hauteur;i++)
    for (j=0;j<largeur;j++)
      mat_out[i*largeur+j]=mat_in[i*largeur+j];
  
  
  /***Copie mat_in dans le fichier file_out au format pgm pour etre visualis par xv par exemple***/
  
  fichier_out=fopen(file_out,"w");
  
  fprintf(fichier_out,"P2\n%d %d \n%d\n",largeur,hauteur,couleur);
  
  for (i=0;i<hauteur;i++)
    for (j=0;j<largeur;j++)
      fprintf(fichier_out,"%d ",mat_out[i*largeur+j]);

  
  fclose(fichier_out);
  
  free(mat_out);
  free(mat_in);
  /***Visualisez l'image resu.pgm avec xv***/
  
  printf("\nSi vous etes sous Unix ou Linux, visualisez simplement avec xv\n");
  
}


